/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools version 0.1.0 Thu Jan 24 08:14:06 2019.
 */

#ifndef TAGS_H
#define TAGS_H

#include <stdint.h>
#include <stdbool.h>

#define EBADWIRETYPE                                   1
#define EOUTOFDATA                                     2

struct tags_heap_t {
    char *buf_p;
    int size;
    int pos;
};

/**
 * Message Message1 in package tags.
 */
struct tags_message_1_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Message Message2 in package tags.
 */
struct tags_message_2_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Message Message2 in package tags.
 */
struct tags_message_3_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Message Message2 in package tags.
 */
struct tags_message_4_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Message Message2 in package tags.
 */
struct tags_message_5_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Message Message2 in package tags.
 */
struct tags_message_6_t {
    struct tags_heap_t *heap_p;
    bool value;
};

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_1_t *tags_message_1_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_1_encode(
    struct tags_message_1_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_1_decode(
    struct tags_message_1_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_2_t *tags_message_2_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_2_encode(
    struct tags_message_2_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_2_decode(
    struct tags_message_2_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_3_t *tags_message_3_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_3_encode(
    struct tags_message_3_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_3_decode(
    struct tags_message_3_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_4_t *tags_message_4_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_4_encode(
    struct tags_message_4_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_4_decode(
    struct tags_message_4_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_5_t *tags_message_5_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_5_encode(
    struct tags_message_5_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_5_decode(
    struct tags_message_5_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message Message in given workspace.
 *
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message_6_t *tags_message_6_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message Message defined in package tags.
 *
 * @param[out] dst_p Buffer to encode into.
 * @param[in] size Size of dst_p.
 * @param[in] src_p Data to encode.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message_6_encode(
    struct tags_message_6_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message Message defined in package tags.
 *
 * @param[out] dst_p Decoded data.
 * @param[in] src_p Data to decode.
 * @param[in] size Size of src_p.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message_6_decode(
    struct tags_message_6_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

#endif
